package io.ient.test;

import io.ient.test.context.FrameworkTestBase;
import io.ient.test.facets.Login;
import io.ient.test.framework.selenium.WaitTime;
import io.ient.test.framework.utils.RandomDataUtils;
import io.ient.test.framework.utils.annotations.TestCaseID;
import io.ient.test.pages.HomePage;
import io.ient.test.pages.enterprise.*;
import org.testng.annotations.Test;
import org.testng.asserts.SoftAssert;

import java.util.List;

public class SuppliersTest extends FrameworkTestBase {

    @TestCaseID(ids = {"T1570"})
    @Test
    public void verifyNewSuppliersCreation() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnEnterprise();
        SuppliersPage suppliersPage = new SuppliersPage(driver);
        suppliersPage.clickOnSuppliersTab();
        String registeredBusinessName = "RBN_" + RandomDataUtils.randomAlphabetic(8);
        String registeredTradeName = "RTN_" + RandomDataUtils.randomAlphabetic(7);
        String businessWebsite = "https://www." + RandomDataUtils.getRandomAlphanumeric(5) + ".com";
        String whichOfTheseLanguagesAreYouDoingBusinessIn = "Lang_" + RandomDataUtils.getRandomAlphanumeric(4);
        String whatIsYourGovernmentIssuesBusinessRegistrationNumber = "RN" + RandomDataUtils.randomNumeric(9);
        String ifYouHaveDunBradstreetNumberDunsPleaseIncludeItHere = RandomDataUtils.randomNumeric(2);
        String inWhatYearWasTheBusinessEstablished = RandomDataUtils.randomNumeric(4);
        String ifYouAreNotTheOwnerWhoEstablishedTheBusinessInWhatYearDidYouAcquireIt = RandomDataUtils.randomNumeric(4);
        String pleaseProvideAShortDescriptionOfYourBusiness = RandomDataUtils.randomAlphabetic(20);
        String pleaseProvideADescriptionOfYourBusinessProductsAndServices = RandomDataUtils.randomAlphabetic(30);
        String primaryProductServiceCategory = "Primary_" + RandomDataUtils.randomAlphabetic(4);
        String secondaryProductServiceCategory = "Secondary_" + RandomDataUtils.randomAlphabetic(4);
        String numberOfFullTimeEmployees = RandomDataUtils.randomNumeric(4);
        String whereDoYouCurrentlyFocusOnSellingYourProductsServices = "CU_" + RandomDataUtils.randomAlphabetic(4);
        String whatAreYourBusinessCurrentAndFutureTargetMarkets = "CU_" + RandomDataUtils.randomAlphabetic(4);
        String otherRelevantBusinessCertificationSForExampleIsoDiversityEnvironmentalEtc = RandomDataUtils.randomAlphabetic(20);
        String inWhichCountriesDoesYourBusinessCurrentlyProvideProductsOrServicesDistributionArea = RandomDataUtils.randomAlphabetic(30);
        String whatIsYourBusinessCurrentLegalStructure = "Structure_" + RandomDataUtils.randomAlphabetic(4);
        String whereIsYourPrincipalPlaceOfBusiness = "Place_" + RandomDataUtils.randomAlphabetic(4);
        String address1 = "AD1_" + RandomDataUtils.getRandomAlphanumeric(4);
        String address2 = "AD2_" + RandomDataUtils.getRandomAlphanumeric(4);
        String town = RandomDataUtils.randomAlphabetic(7);
        String stateProvince = RandomDataUtils.randomAlphabetic(7);
        String zipPostalCode = RandomDataUtils.randomNumeric(6);
        String country = RandomDataUtils.randomAlphabetic(4);
        String useDifferentBillingAddress = RandomDataUtils.getRandomAlphanumeric(4);
        String ownerManagerFirstName = RandomDataUtils.randomAlphabetic(4);
        String ownerManagerLastName = RandomDataUtils.randomAlphabetic(4);
        String ownerManagerGender = RandomDataUtils.randomAlphabetic(4);
        String ownerManagerEmail = RandomDataUtils.randomAlphabetic(5) + "@gmail.com";
        String ownerManagerOfficeNumber = RandomDataUtils.randomNumeric(10);
        String ownerManagerMobileNumber = RandomDataUtils.randomNumeric(10);
        String ownerManagerFaxNumber = RandomDataUtils.randomNumeric(10);
        String whatIsTheOwnerManagersJobTitle = RandomDataUtils.randomAlphabetic(8);
        String whatWereYourBusinessRevenuesIn2020PleaseEnterInUsDollars = RandomDataUtils.getRandomAlphanumeric(4);
        String whatWereYourBusinessRevenuesIn2019PleaseEnterInUsDollars = RandomDataUtils.getRandomAlphanumeric(4);
        suppliersPage.createSuppliers(registeredBusinessName, registeredTradeName, businessWebsite, whichOfTheseLanguagesAreYouDoingBusinessIn, whatIsYourGovernmentIssuesBusinessRegistrationNumber, ifYouHaveDunBradstreetNumberDunsPleaseIncludeItHere, inWhatYearWasTheBusinessEstablished, ifYouAreNotTheOwnerWhoEstablishedTheBusinessInWhatYearDidYouAcquireIt, pleaseProvideAShortDescriptionOfYourBusiness, pleaseProvideADescriptionOfYourBusinessProductsAndServices, primaryProductServiceCategory, secondaryProductServiceCategory, numberOfFullTimeEmployees, whereDoYouCurrentlyFocusOnSellingYourProductsServices, whatAreYourBusinessCurrentAndFutureTargetMarkets, otherRelevantBusinessCertificationSForExampleIsoDiversityEnvironmentalEtc, inWhichCountriesDoesYourBusinessCurrentlyProvideProductsOrServicesDistributionArea, whatIsYourBusinessCurrentLegalStructure, whereIsYourPrincipalPlaceOfBusiness, address1, address2, town, stateProvince, zipPostalCode, country, useDifferentBillingAddress, ownerManagerFirstName, ownerManagerLastName, ownerManagerGender, ownerManagerEmail, ownerManagerOfficeNumber, ownerManagerMobileNumber, ownerManagerFaxNumber, whatIsTheOwnerManagersJobTitle, whatWereYourBusinessRevenuesIn2020PleaseEnterInUsDollars, whatWereYourBusinessRevenuesIn2019PleaseEnterInUsDollars);
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnEnterprise();
        driver.sleep(WaitTime.XSMALL_WAIT);
        suppliersPage.clickOnSuppliersTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        suppliersPage.searchSupplierByName(registeredBusinessName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean displayStatus = suppliersPage.isSupplierDisplayed(registeredBusinessName);
        softAssert.assertTrue(displayStatus, "Failed to create new supplier");
        String updatedName = registeredBusinessName + "_EDIT";
        suppliersPage.editSupplier(updatedName);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        suppliersPage.clearSupplierTextField();
        suppliersPage.searchSupplierByName(updatedName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean updatedSupplierDisplayStatus = suppliersPage.isSupplierDisplayed(updatedName);
        softAssert.assertTrue(updatedSupplierDisplayStatus, "Failed to update supplier");
        suppliersPage.deleteSupplier();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnEnterprise();
        driver.sleep(WaitTime.SMALL_WAIT);
        suppliersPage.clickOnSuppliersTab();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        suppliersPage.clearSupplierTextField();
        suppliersPage.searchSupplierByName(updatedName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        suppliersPage.clickOnSearchIcon();
        boolean isSupplierDeleted = suppliersPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isSupplierDeleted, "Failed to delete supplier");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-1539"})
    @Test
    public void verifyTabsInSuppliersDetails() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnEnterprise();
        SuppliersPage suppliersPage = new SuppliersPage(driver);
        suppliersPage.clickOnSuppliersTab();
        String registeredBusinessName = "RBN_" + RandomDataUtils.randomAlphabetic(8);
        String registeredTradeName = "RTN_" + RandomDataUtils.randomAlphabetic(7);
        String businessWebsite = "https://www." + RandomDataUtils.getRandomAlphanumeric(5) + ".com";
        String whichOfTheseLanguagesAreYouDoingBusinessIn = "Lang_" + RandomDataUtils.getRandomAlphanumeric(4);
        String whatIsYourGovernmentIssuesBusinessRegistrationNumber = "RN" + RandomDataUtils.randomNumeric(9);
        String ifYouHaveDunBradstreetNumberDunsPleaseIncludeItHere = RandomDataUtils.randomNumeric(2);
        String inWhatYearWasTheBusinessEstablished = RandomDataUtils.randomNumeric(4);
        String ifYouAreNotTheOwnerWhoEstablishedTheBusinessInWhatYearDidYouAcquireIt = RandomDataUtils.randomNumeric(4);
        String pleaseProvideAShortDescriptionOfYourBusiness = RandomDataUtils.randomAlphabetic(20);
        String pleaseProvideADescriptionOfYourBusinessProductsAndServices = RandomDataUtils.randomAlphabetic(30);
        String primaryProductServiceCategory = "Primary_" + RandomDataUtils.randomAlphabetic(4);
        String secondaryProductServiceCategory = "Secondary_" + RandomDataUtils.randomAlphabetic(4);
        String numberOfFullTimeEmployees = RandomDataUtils.randomNumeric(4);
        String whereDoYouCurrentlyFocusOnSellingYourProductsServices = "CU_" + RandomDataUtils.randomAlphabetic(4);
        String whatAreYourBusinessCurrentAndFutureTargetMarkets = "CF-" + RandomDataUtils.randomAlphabetic(4);
        String otherRelevantBusinessCertificationSForExampleIsoDiversityEnvironmentalEtc = RandomDataUtils.randomAlphabetic(20);
        String inWhichCountriesDoesYourBusinessCurrentlyProvideProductsOrServicesDistributionArea = RandomDataUtils.randomAlphabetic(30);
        String whatIsYourBusinessCurrentLegalStructure = "Structure_" + RandomDataUtils.randomAlphabetic(4);
        String whereIsYourPrincipalPlaceOfBusiness = "Place_" + RandomDataUtils.randomAlphabetic(4);
        String address1 = "AD1-" + RandomDataUtils.getRandomAlphanumeric(4);
        String address2 = "AD2-" + RandomDataUtils.getRandomAlphanumeric(4);
        String town = RandomDataUtils.randomAlphabetic(7);
        String stateProvince = RandomDataUtils.randomAlphabetic(7);
        String zipPostalCode = RandomDataUtils.randomNumeric(6);
        String country = RandomDataUtils.randomAlphabetic(4);
        String useDifferentBillingAddress = RandomDataUtils.getRandomAlphanumeric(4);
        String ownerManagerFirstName = RandomDataUtils.randomAlphabetic(4);
        String ownerManagerLastName = RandomDataUtils.randomAlphabetic(4);
        String ownerManagerGender = RandomDataUtils.randomAlphabetic(4);
        String ownerManagerEmail = RandomDataUtils.randomAlphabetic(5) + "@gmail.com";
        String ownerManagerOfficeNumber = RandomDataUtils.randomNumeric(10);
        String ownerManagerMobileNumber = RandomDataUtils.randomNumeric(10);
        String ownerManagerFaxNumber = RandomDataUtils.randomNumeric(10);
        String whatIsTheOwnerManagersJobTitle = RandomDataUtils.randomAlphabetic(8);
        String whatWereYourBusinessRevenuesIn2020PleaseEnterInUsDollars = RandomDataUtils.getRandomAlphanumeric(4);
        String whatWereYourBusinessRevenuesIn2019PleaseEnterInUsDollars = RandomDataUtils.getRandomAlphanumeric(4);
        suppliersPage.createSuppliers(registeredBusinessName, registeredTradeName, businessWebsite, whichOfTheseLanguagesAreYouDoingBusinessIn, whatIsYourGovernmentIssuesBusinessRegistrationNumber, ifYouHaveDunBradstreetNumberDunsPleaseIncludeItHere, inWhatYearWasTheBusinessEstablished, ifYouAreNotTheOwnerWhoEstablishedTheBusinessInWhatYearDidYouAcquireIt, pleaseProvideAShortDescriptionOfYourBusiness, pleaseProvideADescriptionOfYourBusinessProductsAndServices, primaryProductServiceCategory, secondaryProductServiceCategory, numberOfFullTimeEmployees, whereDoYouCurrentlyFocusOnSellingYourProductsServices, whatAreYourBusinessCurrentAndFutureTargetMarkets, otherRelevantBusinessCertificationSForExampleIsoDiversityEnvironmentalEtc, inWhichCountriesDoesYourBusinessCurrentlyProvideProductsOrServicesDistributionArea, whatIsYourBusinessCurrentLegalStructure, whereIsYourPrincipalPlaceOfBusiness, address1, address2, town, stateProvince, zipPostalCode, country, useDifferentBillingAddress, ownerManagerFirstName, ownerManagerLastName, ownerManagerGender, ownerManagerEmail, ownerManagerOfficeNumber, ownerManagerMobileNumber, ownerManagerFaxNumber, whatIsTheOwnerManagersJobTitle, whatWereYourBusinessRevenuesIn2020PleaseEnterInUsDollars, whatWereYourBusinessRevenuesIn2019PleaseEnterInUsDollars);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        suppliersPage.searchSupplierByName(registeredBusinessName);
        driver.sleep(WaitTime.SMALL_WAIT);
        boolean displayStatus = suppliersPage.isSupplierDisplayed(registeredBusinessName);
        softAssert.assertTrue(displayStatus, "Failed to create new supplier");
        driver.sleep(WaitTime.SMALL_WAIT);
        suppliersPage.viewSupplier(registeredBusinessName);
        driver.sleep(WaitTime.SMALL_WAIT);
        boolean isSupplierSubTabDisplayed = suppliersPage.isSupplierSubTabDisplayed();
        softAssert.assertTrue(isSupplierSubTabDisplayed, "Failed to display supplier tab");
        boolean isSupplierLocationTabDisplayed = suppliersPage.isSupplierLocationTabDisplayed();
        softAssert.assertTrue(isSupplierLocationTabDisplayed, "Failed to display supplier location tab");
        boolean isSupplierLocationTypesTabDisplayed = suppliersPage.isSupplierLocationTypesTabDisplayed();
        softAssert.assertTrue(isSupplierLocationTypesTabDisplayed, "Failed to display supplier location types tab");
        driver.sleep(WaitTime.XSMALL_WAIT);
        suppliersPage.clickOnGlobalSettingsThroughBreadcrumb();
        suppliersPage.clearSupplierTextField();
        suppliersPage.searchSupplierByName(registeredBusinessName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        suppliersPage.deleteSupplier();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnEnterprise();
        driver.sleep(WaitTime.SMALL_WAIT);
        suppliersPage.clickOnSuppliersTab();
        driver.sleep(WaitTime.SMALL_WAIT);
        suppliersPage.clearSupplierTextField();
        suppliersPage.searchSupplierByName(registeredBusinessName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        suppliersPage.clickOnSearchIcon();
        boolean isSupplierDeleted = suppliersPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isSupplierDeleted, "Failed to delete supplier");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"T1571"})
    @Test
    public void verifyNewSuppliersCreationWithSupplierLocations() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnEnterprise();
        SuppliersPage suppliersPage = new SuppliersPage(driver);
        SupplierLocationsPage supplierLocationsPage = new SupplierLocationsPage(driver);
        suppliersPage.clickOnSuppliersTab();
        String registeredBusinessName = "RBN_" + RandomDataUtils.randomAlphabetic(8);
        String registeredTradeName = "RTN_" + RandomDataUtils.randomAlphabetic(7);
        String businessWebsite = "https://www." + RandomDataUtils.getRandomAlphanumeric(5) + ".com";
        String whichOfTheseLanguagesAreYouDoingBusinessIn = "Lang_" + RandomDataUtils.getRandomAlphanumeric(4);
        String whatIsYourGovernmentIssuesBusinessRegistrationNumber = "RN" + RandomDataUtils.randomNumeric(9);
        String ifYouHaveDunBradstreetNumberDunsPleaseIncludeItHere = RandomDataUtils.randomNumeric(2);
        String inWhatYearWasTheBusinessEstablished = RandomDataUtils.randomNumeric(4);
        String ifYouAreNotTheOwnerWhoEstablishedTheBusinessInWhatYearDidYouAcquireIt = RandomDataUtils.randomNumeric(4);
        String pleaseProvideAShortDescriptionOfYourBusiness = RandomDataUtils.randomAlphabetic(20);
        String pleaseProvideADescriptionOfYourBusinessProductsAndServices = RandomDataUtils.randomAlphabetic(30);
        String primaryProductServiceCategory = "Primary_" + RandomDataUtils.randomAlphabetic(4);
        String secondaryProductServiceCategory = "Secondary_" + RandomDataUtils.randomAlphabetic(4);
        String numberOfFullTimeEmployees = RandomDataUtils.randomNumeric(4);
        String whereDoYouCurrentlyFocusOnSellingYourProductsServices = "CU_" + RandomDataUtils.randomAlphabetic(4);
        String whatAreYourBusinessCurrentAndFutureTargetMarkets = "CU_" + RandomDataUtils.randomAlphabetic(4);
        String otherRelevantBusinessCertificationSForExampleIsoDiversityEnvironmentalEtc = RandomDataUtils.randomAlphabetic(20);
        String inWhichCountriesDoesYourBusinessCurrentlyProvideProductsOrServicesDistributionArea = RandomDataUtils.randomAlphabetic(30);
        String whatIsYourBusinessCurrentLegalStructure = "Structure_" + RandomDataUtils.randomAlphabetic(4);
        String whereIsYourPrincipalPlaceOfBusiness = "Place_" + RandomDataUtils.randomAlphabetic(4);
        String address1 = "AD1_" + RandomDataUtils.getRandomAlphanumeric(4);
        String address2 = "AD2_" + RandomDataUtils.getRandomAlphanumeric(4);
        String town = RandomDataUtils.randomAlphabetic(7);
        String stateProvince = RandomDataUtils.randomAlphabetic(7);
        String zipPostalCode = RandomDataUtils.randomNumeric(6);
        String country = RandomDataUtils.randomAlphabetic(4);
        String useDifferentBillingAddress = RandomDataUtils.getRandomAlphanumeric(4);
        String ownerManagerFirstName = RandomDataUtils.randomAlphabetic(4);
        String ownerManagerLastName = RandomDataUtils.randomAlphabetic(4);
        String ownerManagerGender = RandomDataUtils.randomAlphabetic(4);
        String ownerManagerEmail = RandomDataUtils.randomAlphabetic(5) + "@gmail.com";
        String ownerManagerOfficeNumber = RandomDataUtils.randomNumeric(10);
        String ownerManagerMobileNumber = RandomDataUtils.randomNumeric(10);
        String ownerManagerFaxNumber = RandomDataUtils.randomNumeric(10);
        String whatIsTheOwnerManagersJobTitle = RandomDataUtils.randomAlphabetic(8);
        String whatWereYourBusinessRevenuesIn2020PleaseEnterInUsDollars = RandomDataUtils.getRandomAlphanumeric(4);
        String whatWereYourBusinessRevenuesIn2019PleaseEnterInUsDollars = RandomDataUtils.getRandomAlphanumeric(4);
        suppliersPage.createSuppliers(registeredBusinessName, registeredTradeName, businessWebsite, whichOfTheseLanguagesAreYouDoingBusinessIn, whatIsYourGovernmentIssuesBusinessRegistrationNumber, ifYouHaveDunBradstreetNumberDunsPleaseIncludeItHere, inWhatYearWasTheBusinessEstablished, ifYouAreNotTheOwnerWhoEstablishedTheBusinessInWhatYearDidYouAcquireIt, pleaseProvideAShortDescriptionOfYourBusiness, pleaseProvideADescriptionOfYourBusinessProductsAndServices, primaryProductServiceCategory, secondaryProductServiceCategory, numberOfFullTimeEmployees, whereDoYouCurrentlyFocusOnSellingYourProductsServices, whatAreYourBusinessCurrentAndFutureTargetMarkets, otherRelevantBusinessCertificationSForExampleIsoDiversityEnvironmentalEtc, inWhichCountriesDoesYourBusinessCurrentlyProvideProductsOrServicesDistributionArea, whatIsYourBusinessCurrentLegalStructure, whereIsYourPrincipalPlaceOfBusiness, address1, address2, town, stateProvince, zipPostalCode, country, useDifferentBillingAddress, ownerManagerFirstName, ownerManagerLastName, ownerManagerGender, ownerManagerEmail, ownerManagerOfficeNumber, ownerManagerMobileNumber, ownerManagerFaxNumber, whatIsTheOwnerManagersJobTitle, whatWereYourBusinessRevenuesIn2020PleaseEnterInUsDollars, whatWereYourBusinessRevenuesIn2019PleaseEnterInUsDollars);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        suppliersPage.searchSupplierByName(registeredBusinessName);
        driver.sleep(WaitTime.SMALL_WAIT);
        boolean displayStatus = suppliersPage.isSupplierDisplayed(registeredBusinessName);
        softAssert.assertTrue(displayStatus, "Failed to create new supplier");
        driver.sleep(WaitTime.SMALL_WAIT);
        supplierLocationsPage.clickOnSupplierLocationsTab();
        String locationName = RandomDataUtils.randomAlphabetic(8);
        String businessName = RandomDataUtils.randomAlphabetic(8);
        String street = RandomDataUtils.randomAlphabetic(8);
        String postalCode = RandomDataUtils.randomNumeric(6);
        String city = RandomDataUtils.randomAlphabetic(8);
        String countryInSupplierLocation = RandomDataUtils.randomAlphabetic(8);
        String phoneNumber = RandomDataUtils.randomNumeric(10);
        String fax = RandomDataUtils.randomNumeric(10);
        String duns = RandomDataUtils.randomNumeric(4);
        String countryOfBusinessHq = RandomDataUtils.randomAlphabetic(8);
        String status = "Active";
        supplierLocationsPage.createSupplierLocation(locationName, businessName, street, postalCode, city, countryInSupplierLocation, phoneNumber, fax, duns, countryOfBusinessHq, status);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        supplierLocationsPage.searchLocationByName(locationName);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        boolean locationDisplayStatus = supplierLocationsPage.isLocationDisplayed(locationName);
        softAssert.assertTrue(locationDisplayStatus, "Failed to create new location");
        String updatedLocationName = locationName + "_EDIT";
        supplierLocationsPage.editLocation(updatedLocationName);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        supplierLocationsPage.clearLocationTextField();
        supplierLocationsPage.searchLocationByName(updatedLocationName);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        boolean updatedLocationDisplayStatus = supplierLocationsPage.isLocationDisplayed(updatedLocationName);
        softAssert.assertTrue(updatedLocationDisplayStatus, "Failed to update location");
        supplierLocationsPage.deleteLocation();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        supplierLocationsPage.clearLocationTextField();
        supplierLocationsPage.searchLocationByName(updatedLocationName);
        driver.sleep(WaitTime.SMALL_WAIT);
        supplierLocationsPage.clickOnSearchIcon();
        boolean isSupplierLocationDeleted = supplierLocationsPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isSupplierLocationDeleted, "Failed to delete location");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-2783", "IENT-2694"})
    @Test
    public void verifyNewSuppliersCreationWithSupplierLocationTypes() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnEnterprise();
        SuppliersPage suppliersPage = new SuppliersPage(driver);

        SupplierLocationTypesPage supplierLocationTypesPage = new SupplierLocationTypesPage(driver);
        suppliersPage.clickOnSuppliersTab();

        String registeredBusinessName = "RBN_" + RandomDataUtils.randomAlphabetic(8);
        String registeredTradeName = "RTN_" + RandomDataUtils.randomAlphabetic(7);
        String businessWebsite = "https://www." + RandomDataUtils.getRandomAlphanumeric(5) + ".com";
        String whichOfTheseLanguagesAreYouDoingBusinessIn = "Lang_" + RandomDataUtils.getRandomAlphanumeric(4);
        String whatIsYourGovernmentIssuesBusinessRegistrationNumber = "RN" + RandomDataUtils.randomNumeric(9);
        String ifYouHaveDunBradstreetNumberDunsPleaseIncludeItHere = RandomDataUtils.randomNumeric(2);
        String inWhatYearWasTheBusinessEstablished = RandomDataUtils.randomNumeric(4);
        String ifYouAreNotTheOwnerWhoEstablishedTheBusinessInWhatYearDidYouAcquireIt = RandomDataUtils.randomNumeric(4);
        String pleaseProvideAShortDescriptionOfYourBusiness = RandomDataUtils.randomAlphabetic(20);
        String pleaseProvideADescriptionOfYourBusinessProductsAndServices = RandomDataUtils.randomAlphabetic(30);
        String primaryProductServiceCategory = "Primary_" + RandomDataUtils.randomAlphabetic(4);
        String secondaryProductServiceCategory = "Secondary_" + RandomDataUtils.randomAlphabetic(4);
        String numberOfFullTimeEmployees = RandomDataUtils.randomNumeric(4);
        String whereDoYouCurrentlyFocusOnSellingYourProductsServices = "CU_" + RandomDataUtils.randomAlphabetic(4);
        String whatAreYourBusinessCurrentAndFutureTargetMarkets = "CU_" + RandomDataUtils.randomAlphabetic(4);
        String otherRelevantBusinessCertificationSForExampleIsoDiversityEnvironmentalEtc = RandomDataUtils.randomAlphabetic(20);
        String inWhichCountriesDoesYourBusinessCurrentlyProvideProductsOrServicesDistributionArea = RandomDataUtils.randomAlphabetic(30);
        String whatIsYourBusinessCurrentLegalStructure = "Structure_" + RandomDataUtils.randomAlphabetic(4);
        String whereIsYourPrincipalPlaceOfBusiness = "Place_" + RandomDataUtils.randomAlphabetic(4);
        String address1 = "AD1_" + RandomDataUtils.getRandomAlphanumeric(4);
        String address2 = "AD2_" + RandomDataUtils.getRandomAlphanumeric(4);
        String town = RandomDataUtils.randomAlphabetic(7);
        String stateProvince = RandomDataUtils.randomAlphabetic(7);
        String zipPostalCode = RandomDataUtils.randomNumeric(6);
        String country = RandomDataUtils.randomAlphabetic(4);
        String useDifferentBillingAddress = RandomDataUtils.getRandomAlphanumeric(4);
        String ownerManagerFirstName = RandomDataUtils.randomAlphabetic(4);
        String ownerManagerLastName = RandomDataUtils.randomAlphabetic(4);
        String ownerManagerGender = RandomDataUtils.randomAlphabetic(4);
        String ownerManagerEmail = RandomDataUtils.randomAlphabetic(5) + "@gmail.com";
        String ownerManagerOfficeNumber = RandomDataUtils.randomNumeric(10);
        String ownerManagerMobileNumber = RandomDataUtils.randomNumeric(10);
        String ownerManagerFaxNumber = RandomDataUtils.randomNumeric(10);
        String whatIsTheOwnerManagersJobTitle = RandomDataUtils.randomAlphabetic(8);
        String whatWereYourBusinessRevenuesIn2020PleaseEnterInUsDollars = RandomDataUtils.getRandomAlphanumeric(4);
        String whatWereYourBusinessRevenuesIn2019PleaseEnterInUsDollars = RandomDataUtils.getRandomAlphanumeric(4);
        suppliersPage.createSuppliers(registeredBusinessName, registeredTradeName, businessWebsite, whichOfTheseLanguagesAreYouDoingBusinessIn, whatIsYourGovernmentIssuesBusinessRegistrationNumber, ifYouHaveDunBradstreetNumberDunsPleaseIncludeItHere, inWhatYearWasTheBusinessEstablished, ifYouAreNotTheOwnerWhoEstablishedTheBusinessInWhatYearDidYouAcquireIt, pleaseProvideAShortDescriptionOfYourBusiness, pleaseProvideADescriptionOfYourBusinessProductsAndServices, primaryProductServiceCategory, secondaryProductServiceCategory, numberOfFullTimeEmployees, whereDoYouCurrentlyFocusOnSellingYourProductsServices, whatAreYourBusinessCurrentAndFutureTargetMarkets, otherRelevantBusinessCertificationSForExampleIsoDiversityEnvironmentalEtc, inWhichCountriesDoesYourBusinessCurrentlyProvideProductsOrServicesDistributionArea, whatIsYourBusinessCurrentLegalStructure, whereIsYourPrincipalPlaceOfBusiness, address1, address2, town, stateProvince, zipPostalCode, country, useDifferentBillingAddress, ownerManagerFirstName, ownerManagerLastName, ownerManagerGender, ownerManagerEmail, ownerManagerOfficeNumber, ownerManagerMobileNumber, ownerManagerFaxNumber, whatIsTheOwnerManagersJobTitle, whatWereYourBusinessRevenuesIn2020PleaseEnterInUsDollars, whatWereYourBusinessRevenuesIn2019PleaseEnterInUsDollars);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        suppliersPage.searchSupplierByName(registeredBusinessName);
        driver.sleep(WaitTime.SMALL_WAIT);
        boolean displayStatus = suppliersPage.isSupplierDisplayed(registeredBusinessName);
        softAssert.assertTrue(displayStatus, "Failed to create new supplier");
        driver.sleep(WaitTime.SMALL_WAIT);

        supplierLocationTypesPage.clickOnSupplierLocationTypesTab();
        String name = RandomDataUtils.randomAlphabetic(8);
        String description = RandomDataUtils.randomAlphabetic(8);

        supplierLocationTypesPage.createSupplierLocationType(name, description);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        supplierLocationTypesPage.searchByName(name);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        boolean nameDisplayStatus = supplierLocationTypesPage.isNameDisplayed(name);
        softAssert.assertTrue(nameDisplayStatus, "Failed to create new location type");
        String updatedName = name + "_EDIT";
        supplierLocationTypesPage.editLocationType(updatedName);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        supplierLocationTypesPage.clearNameTextField();
        supplierLocationTypesPage.searchByName(updatedName);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        boolean updatedNameDisplayStatus = supplierLocationTypesPage.isNameDisplayed(updatedName);
        softAssert.assertTrue(updatedNameDisplayStatus, "Failed to update location type");
        supplierLocationTypesPage.deleteLocationType();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        supplierLocationTypesPage.clearNameTextField();
        supplierLocationTypesPage.searchByName(updatedName);
        driver.sleep(WaitTime.SMALL_WAIT);
        supplierLocationTypesPage.clickOnSearchIcon();
        boolean isSupplierLocationTypeDeleted = supplierLocationTypesPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isSupplierLocationTypeDeleted, "Failed to delete location type");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-1178" , "IENT-1179" , "IENT-1184" , "IENT-1318" , "IENT-1320"})
    @Test
    public void verifySuppliersWithSupplierRoles() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnEnterprise();
        SuppliersPage suppliersPage = new SuppliersPage(driver);
        suppliersPage.clickOnSuppliersTab();
        String registeredBusinessName = "RBN_" + RandomDataUtils.randomAlphabetic(8);
        String registeredTradeName = "RTN_" + RandomDataUtils.randomAlphabetic(7);
        String businessWebsite = "https://www." + RandomDataUtils.getRandomAlphanumeric(5) + ".com";
        String whichOfTheseLanguagesAreYouDoingBusinessIn = "Lang_" + RandomDataUtils.getRandomAlphanumeric(4);
        String whatIsYourGovernmentIssuesBusinessRegistrationNumber = "RN" + RandomDataUtils.randomNumeric(9);
        String ifYouHaveDunBradstreetNumberDunsPleaseIncludeItHere = RandomDataUtils.randomNumeric(2);
        String inWhatYearWasTheBusinessEstablished = RandomDataUtils.randomNumeric(4);
        String ifYouAreNotTheOwnerWhoEstablishedTheBusinessInWhatYearDidYouAcquireIt = RandomDataUtils.randomNumeric(4);
        String pleaseProvideAShortDescriptionOfYourBusiness = RandomDataUtils.randomAlphabetic(20);
        String pleaseProvideADescriptionOfYourBusinessProductsAndServices = RandomDataUtils.randomAlphabetic(30);
        String primaryProductServiceCategory = "Primary_" + RandomDataUtils.randomAlphabetic(4);
        String secondaryProductServiceCategory = "Secondary_" + RandomDataUtils.randomAlphabetic(4);
        String numberOfFullTimeEmployees = RandomDataUtils.randomNumeric(4);
        String whereDoYouCurrentlyFocusOnSellingYourProductsServices = "CU_" + RandomDataUtils.randomAlphabetic(4);
        String whatAreYourBusinessCurrentAndFutureTargetMarkets = "CU_" + RandomDataUtils.randomAlphabetic(4);
        String otherRelevantBusinessCertificationSForExampleIsoDiversityEnvironmentalEtc = RandomDataUtils.randomAlphabetic(20);
        String inWhichCountriesDoesYourBusinessCurrentlyProvideProductsOrServicesDistributionArea = RandomDataUtils.randomAlphabetic(30);
        String whatIsYourBusinessCurrentLegalStructure = "Structure_" + RandomDataUtils.randomAlphabetic(4);
        String whereIsYourPrincipalPlaceOfBusiness = "Place_" + RandomDataUtils.randomAlphabetic(4);
        String address1 = "AD1_" + RandomDataUtils.getRandomAlphanumeric(4);
        String address2 = "AD2_" + RandomDataUtils.getRandomAlphanumeric(4);
        String town = RandomDataUtils.randomAlphabetic(7);
        String stateProvince = RandomDataUtils.randomAlphabetic(7);
        String zipPostalCode = RandomDataUtils.randomNumeric(6);
        String country = RandomDataUtils.randomAlphabetic(4);
        String useDifferentBillingAddress = RandomDataUtils.getRandomAlphanumeric(4);
        String ownerManagerFirstName = RandomDataUtils.randomAlphabetic(4);
        String ownerManagerLastName = RandomDataUtils.randomAlphabetic(4);
        String ownerManagerGender = RandomDataUtils.randomAlphabetic(4);
        String ownerManagerEmail = RandomDataUtils.randomAlphabetic(5) + "@gmail.com";
        String ownerManagerOfficeNumber = RandomDataUtils.randomNumeric(10);
        String ownerManagerMobileNumber = RandomDataUtils.randomNumeric(10);
        String ownerManagerFaxNumber = RandomDataUtils.randomNumeric(10);
        String whatIsTheOwnerManagersJobTitle = RandomDataUtils.randomAlphabetic(8);
        String whatWereYourBusinessRevenuesIn2020PleaseEnterInUsDollars = RandomDataUtils.getRandomAlphanumeric(4);
        String whatWereYourBusinessRevenuesIn2019PleaseEnterInUsDollars = RandomDataUtils.getRandomAlphanumeric(4);
        suppliersPage.createSuppliers(registeredBusinessName, registeredTradeName, businessWebsite, whichOfTheseLanguagesAreYouDoingBusinessIn, whatIsYourGovernmentIssuesBusinessRegistrationNumber, ifYouHaveDunBradstreetNumberDunsPleaseIncludeItHere, inWhatYearWasTheBusinessEstablished, ifYouAreNotTheOwnerWhoEstablishedTheBusinessInWhatYearDidYouAcquireIt, pleaseProvideAShortDescriptionOfYourBusiness, pleaseProvideADescriptionOfYourBusinessProductsAndServices, primaryProductServiceCategory, secondaryProductServiceCategory, numberOfFullTimeEmployees, whereDoYouCurrentlyFocusOnSellingYourProductsServices, whatAreYourBusinessCurrentAndFutureTargetMarkets, otherRelevantBusinessCertificationSForExampleIsoDiversityEnvironmentalEtc, inWhichCountriesDoesYourBusinessCurrentlyProvideProductsOrServicesDistributionArea, whatIsYourBusinessCurrentLegalStructure, whereIsYourPrincipalPlaceOfBusiness, address1, address2, town, stateProvince, zipPostalCode, country, useDifferentBillingAddress, ownerManagerFirstName, ownerManagerLastName, ownerManagerGender, ownerManagerEmail, ownerManagerOfficeNumber, ownerManagerMobileNumber, ownerManagerFaxNumber, whatIsTheOwnerManagersJobTitle, whatWereYourBusinessRevenuesIn2020PleaseEnterInUsDollars, whatWereYourBusinessRevenuesIn2019PleaseEnterInUsDollars);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        suppliersPage.searchSupplierByName(registeredBusinessName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean displayStatus = suppliersPage.isSupplierDisplayed(registeredBusinessName);
        softAssert.assertTrue(displayStatus, "Failed to create new supplier");
        homePage.clickOnEnterprise();
        UserManagementPage UserManagementPage = new UserManagementPage(driver);
        UserManagementPage.clickOnUserManagementTab();
        String saUserName = "User_" + RandomDataUtils.getRandomAlphanumeric(5);
        saUserName = saUserName.toLowerCase();
        String saFirstName = RandomDataUtils.getRandomAlphanumeric(5).toLowerCase();;
        String lastName = RandomDataUtils.getRandomAlphanumeric(5).toLowerCase();;
        String saEmailAddress = RandomDataUtils.getRandomAlphanumeric(5).toLowerCase() + "@gmail.com";
        String sA_role = "Supplier Admin";
        String salutation = "Mrs";
        String status = "Active";
        UserManagementPage.createUser(saUserName, saFirstName, lastName, saEmailAddress, sA_role, salutation, status, registeredBusinessName);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        UserManagementPage.searchUserByUserName(saUserName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean sa_displayStatus = UserManagementPage.isUserDisplayed(saUserName, saFirstName);
        softAssert.assertTrue(sa_displayStatus, "Failed to create new user with supplier admin role");
        String suUserName = "SUser_" + RandomDataUtils.getRandomAlphanumeric(5);
        suUserName = suUserName.toLowerCase();
        String firstName = RandomDataUtils.getRandomAlphanumeric(5).toLowerCase();
        lastName = RandomDataUtils.getRandomAlphanumeric(5).toLowerCase();
        String suEmailAddress = RandomDataUtils.getRandomAlphanumeric(5).toLowerCase() + "@gmail.com";
        String su_role = "Supplier User";
        salutation = "Mrs";
        status = "Active";
        String password = "Test@1234";
        UserManagementPage.createUser(suUserName, firstName, lastName, suEmailAddress, su_role, salutation, status, registeredBusinessName);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        UserManagementPage.searchUserByUserName(suUserName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        displayStatus = UserManagementPage.isUserDisplayed(suUserName, firstName);
        softAssert.assertTrue(displayStatus, "Failed to create new user with supplier user role");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        KeyCloakPage keyCloakPage = new KeyCloakPage(driver);
        login.loginToKeycloak(testContext.app);
        String tenantName = testContext.app.getAgency().toLowerCase();
        keyCloakPage.clickOnTenantName(tenantName);
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.clickOnUsers();
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.clickOnViewAllUsers();
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.searchUserByName(saUserName);
        keyCloakPage.updateUserPassword(saUserName, password);
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.clickOnUsers();
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.clickOnViewAllUsers();
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.searchUserByName(suUserName);
        keyCloakPage.updateUserPassword(suUserName, password);
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.clickOnAdminDropDownLink();
        keyCloakPage.clickOnSignOutLink();
        driver.sleep(WaitTime.XSMALL_WAIT);
        TenantsPage tenantsPage = new TenantsPage(driver);
        login.loginWithUserCredentialsWithoutValidation(tenantName, saUserName, password, testContext.app);
        homePage.clickOnAcceptTermsAndConditions();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        tenantsPage.clickOnSubmitButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithUserCredentialsWithoutValidation(tenantName, suUserName, password, testContext.app);
        homePage.clickOnAcceptTermsAndConditions();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        tenantsPage.clickOnSubmitButton();
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        login.loginWithBuyerAdmin(testContext.app);
        homePage.clickOnEnterprise();
        suppliersPage.clickOnSuppliersTab();
        suppliersPage.clearSupplierTextField();
        suppliersPage.searchSupplierByName(registeredBusinessName);
        List<String> usersList = suppliersPage.getSupplierUsersList();
        boolean suppler_user_in_users_dropdown = usersList.contains(suUserName);
        softAssert.assertFalse(suppler_user_in_users_dropdown, "Supplier role user found in supplier users dropdown");
        boolean suppler_admin_in_users_dropdown = usersList.contains(saUserName);
        softAssert.assertTrue(suppler_admin_in_users_dropdown, "Failed to find supplier admin role user found in supplier users dropdown");
        driver.sleep(WaitTime.MEDIUM_WAIT);
        suppliersPage.clearSupplierTextField();
        suppliersPage.searchSupplierByName(registeredBusinessName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        suppliersPage.editSupplierWithSupplierUser(registeredBusinessName, saUserName);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnEnterprise();
        UserManagementPage.clickOnUserManagementTab();
        UserManagementPage.clearSearchTextField();
        UserManagementPage.searchUserByUserName(saUserName);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        UserManagementPage.deleteUser();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        UserManagementPage.searchUserByUserName(saUserName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        displayStatus = UserManagementPage.isUserDisplayed(saUserName, saFirstName);
        softAssert.assertTrue(displayStatus, "Able to delete supplier admin user which has association as a supplier");
        UserManagementPage.clearSearchTextField();
        UserManagementPage.searchUserByUserName(suUserName);
        driver.sleep(WaitTime.SMALL_WAIT);
        UserManagementPage.deleteUser();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        UserManagementPage.clearSearchTextField();
        UserManagementPage.searchUserByUserName(suUserName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        UserManagementPage.clickOnSearchIcon();
        boolean isUserDeleted = UserManagementPage.verifyNoRecordsMessage();
        softAssert.assertTrue(isUserDeleted, "Failed to delete supplier user");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-1322"})
    @Test
    public void verifySuppliersWithSupplierAdminEdit() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnEnterprise();
        SuppliersPage suppliersPage = new SuppliersPage(driver);
        suppliersPage.clickOnSuppliersTab();
        String registeredBusinessName = "RBN_" + RandomDataUtils.randomAlphabetic(8);
        String registeredTradeName = "RTN_" + RandomDataUtils.randomAlphabetic(7);
        String businessWebsite = "https://www." + RandomDataUtils.getRandomAlphanumeric(5) + ".com";
        String whichOfTheseLanguagesAreYouDoingBusinessIn = "Lang_" + RandomDataUtils.getRandomAlphanumeric(4);
        String whatIsYourGovernmentIssuesBusinessRegistrationNumber = "RN" + RandomDataUtils.randomNumeric(9);
        String ifYouHaveDunBradstreetNumberDunsPleaseIncludeItHere = RandomDataUtils.randomNumeric(2);
        String inWhatYearWasTheBusinessEstablished = RandomDataUtils.randomNumeric(4);
        String ifYouAreNotTheOwnerWhoEstablishedTheBusinessInWhatYearDidYouAcquireIt = RandomDataUtils.randomNumeric(4);
        String pleaseProvideAShortDescriptionOfYourBusiness = RandomDataUtils.randomAlphabetic(20);
        String pleaseProvideADescriptionOfYourBusinessProductsAndServices = RandomDataUtils.randomAlphabetic(30);
        String primaryProductServiceCategory = "Primary_" + RandomDataUtils.randomAlphabetic(4);
        String secondaryProductServiceCategory = "Secondary_" + RandomDataUtils.randomAlphabetic(4);
        String numberOfFullTimeEmployees = RandomDataUtils.randomNumeric(4);
        String whereDoYouCurrentlyFocusOnSellingYourProductsServices = "CU_" + RandomDataUtils.randomAlphabetic(4);
        String whatAreYourBusinessCurrentAndFutureTargetMarkets = "CU_" + RandomDataUtils.randomAlphabetic(4);
        String otherRelevantBusinessCertificationSForExampleIsoDiversityEnvironmentalEtc = RandomDataUtils.randomAlphabetic(20);
        String inWhichCountriesDoesYourBusinessCurrentlyProvideProductsOrServicesDistributionArea = RandomDataUtils.randomAlphabetic(30);
        String whatIsYourBusinessCurrentLegalStructure = "Structure_" + RandomDataUtils.randomAlphabetic(4);
        String whereIsYourPrincipalPlaceOfBusiness = "Place_" + RandomDataUtils.randomAlphabetic(4);
        String address1 = "AD1_" + RandomDataUtils.getRandomAlphanumeric(4);
        String address2 = "AD2_" + RandomDataUtils.getRandomAlphanumeric(4);
        String town = RandomDataUtils.randomAlphabetic(7);
        String stateProvince = RandomDataUtils.randomAlphabetic(7);
        String zipPostalCode = RandomDataUtils.randomNumeric(6);
        String country = RandomDataUtils.randomAlphabetic(4);
        String useDifferentBillingAddress = RandomDataUtils.getRandomAlphanumeric(4);
        String ownerManagerFirstName = RandomDataUtils.randomAlphabetic(4);
        String ownerManagerLastName = RandomDataUtils.randomAlphabetic(4);
        String ownerManagerGender = RandomDataUtils.randomAlphabetic(4);
        String ownerManagerEmail = RandomDataUtils.randomAlphabetic(5) + "@gmail.com";
        String ownerManagerOfficeNumber = RandomDataUtils.randomNumeric(10);
        String ownerManagerMobileNumber = RandomDataUtils.randomNumeric(10);
        String ownerManagerFaxNumber = RandomDataUtils.randomNumeric(10);
        String whatIsTheOwnerManagersJobTitle = RandomDataUtils.randomAlphabetic(8);
        String whatWereYourBusinessRevenuesIn2020PleaseEnterInUsDollars = RandomDataUtils.getRandomAlphanumeric(4);
        String whatWereYourBusinessRevenuesIn2019PleaseEnterInUsDollars = RandomDataUtils.getRandomAlphanumeric(4);
        suppliersPage.createSuppliers(registeredBusinessName, registeredTradeName, businessWebsite, whichOfTheseLanguagesAreYouDoingBusinessIn, whatIsYourGovernmentIssuesBusinessRegistrationNumber, ifYouHaveDunBradstreetNumberDunsPleaseIncludeItHere, inWhatYearWasTheBusinessEstablished, ifYouAreNotTheOwnerWhoEstablishedTheBusinessInWhatYearDidYouAcquireIt, pleaseProvideAShortDescriptionOfYourBusiness, pleaseProvideADescriptionOfYourBusinessProductsAndServices, primaryProductServiceCategory, secondaryProductServiceCategory, numberOfFullTimeEmployees, whereDoYouCurrentlyFocusOnSellingYourProductsServices, whatAreYourBusinessCurrentAndFutureTargetMarkets, otherRelevantBusinessCertificationSForExampleIsoDiversityEnvironmentalEtc, inWhichCountriesDoesYourBusinessCurrentlyProvideProductsOrServicesDistributionArea, whatIsYourBusinessCurrentLegalStructure, whereIsYourPrincipalPlaceOfBusiness, address1, address2, town, stateProvince, zipPostalCode, country, useDifferentBillingAddress, ownerManagerFirstName, ownerManagerLastName, ownerManagerGender, ownerManagerEmail, ownerManagerOfficeNumber, ownerManagerMobileNumber, ownerManagerFaxNumber, whatIsTheOwnerManagersJobTitle, whatWereYourBusinessRevenuesIn2020PleaseEnterInUsDollars, whatWereYourBusinessRevenuesIn2019PleaseEnterInUsDollars);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        suppliersPage.searchSupplierByName(registeredBusinessName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean displayStatus = suppliersPage.isSupplierDisplayed(registeredBusinessName);
        softAssert.assertTrue(displayStatus, "Failed to create new supplier");
        homePage.clickOnEnterprise();
        UserManagementPage UserManagementPage = new UserManagementPage(driver);
        UserManagementPage.clickOnUserManagementTab();
        String saUserName = "User_" + RandomDataUtils.getRandomAlphanumeric(5);
        saUserName = saUserName.toLowerCase();
        String firstName = RandomDataUtils.getRandomAlphanumeric(5).toLowerCase();;
        String lastName = RandomDataUtils.getRandomAlphanumeric(5).toLowerCase();;
        String saEmailAddress = RandomDataUtils.getRandomAlphanumeric(5).toLowerCase() + "@gmail.com";
        String sA_role = "Supplier Admin";
        String salutation = "Mrs";
        String status = "Active";
        String password = "Test@1234";
        UserManagementPage.createUser(saUserName, firstName, lastName, saEmailAddress, sA_role, salutation, status, registeredBusinessName);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        UserManagementPage.searchUserByUserName(saUserName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean sa_displayStatus = UserManagementPage.isUserDisplayed(saUserName, firstName);
        softAssert.assertTrue(sa_displayStatus, "Failed to create new user with supplier admin role");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        KeyCloakPage keyCloakPage = new KeyCloakPage(driver);
        login.loginToKeycloak(testContext.app);
        String tenantName = testContext.app.getAgency().toLowerCase();
        keyCloakPage.clickOnTenantName(tenantName);
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.clickOnUsers();
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.clickOnViewAllUsers();
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.searchUserByName(saUserName);
        keyCloakPage.updateUserPassword(saUserName, password);
        driver.sleep(WaitTime.SMALL_WAIT);
        keyCloakPage.clickOnAdminDropDownLink();
        keyCloakPage.clickOnSignOutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        TenantsPage tenantsPage = new TenantsPage(driver);
        login.loginWithUserCredentialsWithoutValidation(tenantName, saUserName, password, testContext.app);
        homePage.clickOnAcceptTermsAndConditions();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        tenantsPage.clickOnSubmitButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerAdmin(testContext.app);
        homePage.clickOnEnterprise();
        suppliersPage.clickOnSuppliersTab();
        suppliersPage.clearSupplierTextField();
        suppliersPage.searchSupplierByName(registeredBusinessName);
        driver.sleep(WaitTime.SMALL_WAIT);
        List<String> usersList = suppliersPage.getSupplierUsersList();
        boolean suppler_admin_in_users_dropdown = usersList.contains(saUserName);
        softAssert.assertTrue(suppler_admin_in_users_dropdown, "Failed to find supplier admin role user found in supplier users dropdown");
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnEnterprise();
        UserManagementPage.clickOnUserManagementTab();
        UserManagementPage.clearSearchTextField();
        UserManagementPage.searchUserByUserName(saUserName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        String supplier_name_updated = "JM Polymer";
        UserManagementPage.editUserSupplier(supplier_name_updated);
        homePage.clickOnEnterprise();
        suppliersPage.clickOnSuppliersTab();
        suppliersPage.clearSupplierTextField();
        suppliersPage.searchSupplierByName(registeredBusinessName);
        driver.sleep(WaitTime.XSMALL_WAIT);
        String actualText = suppliersPage.getSupplierUserText();
        boolean selected_supplier_status = actualText.contains(supplier_name_updated);
        softAssert.assertTrue(selected_supplier_status, "Failed to find updated supplier admin role user in supplier users dropdown");
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnEnterprise();
        UserManagementPage.clickOnUserManagementTab();
        UserManagementPage.clearSearchTextField();
        UserManagementPage.searchUserByUserName(saUserName);
        driver.sleep(WaitTime.SMALL_WAIT);
        UserManagementPage.deleteUser();
        softAssert.assertAll();
    }
}